package com.engine.organization.mapper.staff;


import com.engine.organization.entity.staff.po.StaffPlanPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/25
 * @Version V1.0
 **/
public interface StaffPlanMapper {

    /**
     * 根据No查询编制方案
     *
     * @param planNo
     * @return
     */
    List<StaffPlanPO> listByNo(@Param("planNo") String planNo);


    List<Map<String, Object>> listPlansByIds(@Param("ids") Collection<Long> ids);

    /**
     * 根据ID查询编制方案
     *
     * @param id
     * @return
     */
    StaffPlanPO getStaffPlanByID(@Param("id") long id);

    /**
     * 插入编制方案
     *
     * @param staffPlanPO
     * @return
     */
    int insertIgnoreNull(StaffPlanPO staffPlanPO);

    /**
     * 修改，修改所有字段
     *
     * @param staffPlanPO
     * @return
     */
    int updateStaffPlan(StaffPlanPO staffPlanPO);

    /**
     * 更新禁用标记
     *
     * @param staffPlanPO
     * @return
     */
    int updateForbiddenTagById(StaffPlanPO staffPlanPO);

    /**
     * 批量删除
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 查询所有被引用的ID
     *
     * @return
     */
    List<String> listUsedId();

    List<StaffPlanPO> getStaffPlansByIds(@Param("ids") Collection<Long> ids);
}
